{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module OGDF.OptimalHierarchyLayout.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import OGDF.OptimalHierarchyLayout.RawType
import OGDF.OptimalHierarchyLayout.FFI
import OGDF.OptimalHierarchyLayout.Interface
import OGDF.OptimalHierarchyLayout.Cast
import OGDF.OptimalHierarchyLayout.RawType
import OGDF.OptimalHierarchyLayout.Cast
import OGDF.OptimalHierarchyLayout.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface
import OGDF.HierarchyLayoutModule.RawType
import OGDF.HierarchyLayoutModule.Cast
import OGDF.HierarchyLayoutModule.Interface

instance () => IOptimalHierarchyLayout (OptimalHierarchyLayout)
         where

instance () => IDeletable (OptimalHierarchyLayout) where
        delete = xform0 c_optimalhierarchylayout_delete

instance () => IHierarchyLayoutModule (OptimalHierarchyLayout)
         where

newOptimalHierarchyLayout :: () => IO OptimalHierarchyLayout
newOptimalHierarchyLayout
  = xformnull c_optimalhierarchylayout_newoptimalhierarchylayout

optimalHierarchyLayout_layerDistance ::
                                       () => OptimalHierarchyLayout -> CDouble -> IO ()
optimalHierarchyLayout_layerDistance
  = xform1
      c_optimalhierarchylayout_optimalhierarchylayout_layerdistance

optimalHierarchyLayout_nodeDistance ::
                                      () => OptimalHierarchyLayout -> CDouble -> IO ()
optimalHierarchyLayout_nodeDistance
  = xform1
      c_optimalhierarchylayout_optimalhierarchylayout_nodedistance

optimalHierarchyLayout_weightBalancing ::
                                         () => OptimalHierarchyLayout -> CDouble -> IO ()
optimalHierarchyLayout_weightBalancing
  = xform1
      c_optimalhierarchylayout_optimalhierarchylayout_weightbalancing
